from pymongo import MongoClient
from datetime import datetime


class EncoursDao:
    client = MongoClient('localhost', 27017)

    ## extraction d'une base de données. Si elle n'existe pas, elle esst créée
    base_donnees = client.squelette

    ## Fonction qui permet de savoir si un contenu en cours à fait l'objet d'une demande de publication
    # @param idEnCours l'id du contenu en cours
    def is_en_cours_demande(self, idEnCours, auteur):
        return self.base_donnees.demandesPub.find({"id": idEnCours} and {"auteurDemande": auteur}).count() != 0

    ## récupérer l'auteur initial d'un contenu en cours (peut être l'auteur effectuant la modification ou non)
    # @param idContenuEnCours l'id du contenu en cours de modification
    @staticmethod
    def get_auteur_origine_contenu_en_cours(self, id_contenu_en_cours):
        id_contenu = self.base_donnees.find_one({"idContenuEC": id_contenu_en_cours})["reference"]
        return self.base_donnees.contenu.find_one({"id": id_contenu})["auteur"]

    ## récupérer la branche d'un contenu en cours
    # @param idContenuEnCours l'id du contenu en cours de modification
    def get_contenu_en_cours(self, id_contenu_en_cours):
        # id_contenu = Utils.getIdContenuAssocieAUnEnCours(idContenuEnCours)
        return self.base_donnees.find_one({"idContenuEC": id_contenu_en_cours})

    ## supprimer un contenu en cours
    # @param idContenuEnCours id du contenu a supprimer
    def supprimer_contenu_en_cours(self, idContenuEnCours):
        self.base_donnees.delete_one({"idContenuEC": idContenuEnCours})


    def get_max_id_contenus_en_cours(self):
        ## Fonction permettant de récupérer l'id max présent en base (pour pouvoir incrémenter un nouveau contenu).
        element = self.base_donnees.find().sort("idContenuEC", -1).limit(1)

        for elt in element:
            # print("id : ", elt)
            return int(elt["idContenuEC"])

    def creer_en_cours(self, idContenu, version, nomBranche):
        max_id_encours = Utils.get_max_id_contenus_en_cours()
        if max_id_encours is None:
            max_id_encours = 0
        Utils.statdb.encours.insert_one(
            {"idContenuEC": max_id_encours + 1, "date": datetime.now().strftime("%d/%m/%y"), "auteur": auteur,
             "reference": int(idContenu), "version": version, "branche": nomBranche})
